<?php
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
  <title></title>
  <meta name="GENERATOR" content="Quanta Plus">
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

</head>
<body>


<?php
include_once("utility.php");
include_once("utility_html.php");

// create the class database 
$db_conf=get_db_conf_file("db/db_conf.txt");
// new_db_class isn't a constructor but an utility that is generating a class name
// and create an instance of it 
if (!isset($db))
{
	$db=new_db_class($db_conf);
	if ($err[0])
	{
	
		die(	
		sprint_error(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n"
							."Can not create the database interface class with the configuration file $db_conf"
						)
			);
		
	}
	else
	{
			print ("<br>db class creation ok");
	}
	// connect to the database
	$db->db_connect();
	if ($db->err[0])
	{
		die(	
		sprint_error(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n"
							."Can not connect to the database see the application log-file"
						)
			);	
			
		
	}
	else
	{
			print ("<br>db connection ok");
	}
}
// prepare the sql statement to be executed
switch($db->db_manufacturer)
{
	case 'mysql':
		$auto_key="auto_increment";
		$auto_key_type="integer";
		$key_type="integer";
		break;
	case 'postgree':
		$auto_key="";
		$auto_key_type="serial";
		$key_type="integer";
		break;
	default:
		break;
}
$req_tab=array(
"drope table users cascade"=>"drop table users cascade"
, 
"create table users"=>"create table users 
(
	us_user_id 					$auto_key_type $auto_key, 
	us_user_name				char(20),
	us_encrypted_paswd		varchar(255),
	us_email						varchar(255),
	primary key(us_user_id)
) 
"
,
"drope table rubric cascade"=>"drop table rubric cascade"
, 
"create table rubric"=>"create table rubric 
(
	ru_rubric_id 				$auto_key_type $auto_key, 
	ru_rubric_name 			char(20),
	primary key(ru_rubric_id)
) 
"
,
"drope table rubructree cascade"=>"drop table rubrictree cascade"
, 
"create table rubrictree"=>"create table rubrictree 
(
	tr_rubric_id 				$key_type  , 
	tr_sub_rubric_id    		$key_type  
	
)
"
,
"create index tr_two"=>"create index tr_two on rubrictree (tr_sub_rubric_id,tr_rubric_id)"
,
"drope table characteristic cascade"=>"drop table characteristic cascade"
, 
"create table characteristic"=>"create table characteristic 
(
	ch_charac_id 						$auto_key_type  $auto_key, 
	ch_charac_type 					varchar(255), 
	ch_charac_name						char(40),
	ch_input_html_type	 			varchar(255),		
	ch_input_length 					int2, 
	ch_input_decimal 					int2, 
	ch_max_range						float,
	ch_min_range						float,
	ch_ctl_type							varchar(255),
	ch_unit_id							$key_type ,
	primary key(ch_charac_id)
)
"
,
"drope table input_values cascade"=>"drop table input_values cascade"
, 

"create table input_values"=>"create table input_values 
(
	iv_input_values_id 				$auto_key_type $auto_key, 
	iv_charac_id		 				$key_type ,  
	iv_sequence							int2,
	iv_input_values					varchar(255),
	primary key(iv_input_values_id)	
)
"
,
"create index iv_one"=>"create index iv_one on input_values(iv_charac_id,iv_sequence)"	
,
"drope table unit cascade"=>"drop table unit cascade"
, 

"create table unit"=>"create table unit 
(
	un_unit_id 				$auto_key_type  $auto_key, 
	un_unit_name     		char(30),
	primary key(un_unit_id)
)
"
,
"drope table coeff_unit cascade"=>"drop table coeff_unit cascade"
, 

"create table coeff_unit"=>"create table coeff_unit 
(
	cu_coeff_unit_id		$auto_key_type $auto_key,
	cu_unit_id 				$key_type  , 
	cu_sequence				int2,
	cu_abbrev				char(10),
	cu_coeff_value			float,
	primary key(cu_coeff_unit_id)
)
"
,
"create index cu_one"=>"create index cu_one on coeff_unit (cu_coeff_unit_id,cu_sequence)"
,
"drope table obj_type cascade"=>"drop table obj_type cascade"
, 
"create table obj_type"=>"create table obj_type 
(
	ot_obj_type_id	 		$auto_key_type $auto_key, 
	ot_obj_name		    	char(30),
	ot_rubric_id			$key_type ,
	primary key(ot_obj_type_id	)
)
"
,
"create index ot_one"=>"create index ot_one on obj_type (ot_rubric_id)"
,
"drope table obj_charac cascade"=>"drop table obj_charac cascade"
, 

"create table obj_charac"=>"create table obj_charac 
(
	oc_obj_type_id	 			$key_type ,
	oc_sequence					int2,
	oc_charac_id				$key_type ,
	oc_required					bool,
	oc_multi_occur				bool,
	oc_init_occur				int default 1, 
	unique (oc_obj_type_id,oc_charac_id)
)
"
,
"create index oc_one"=>"create index  oc_one on obj_charac (oc_obj_type_id,oc_sequence)"
,
"drope table obj_stock cascade"=>"drop table obj_stock cascade"
, 
"create table obj_stock"=>"create table obj_stock 
(
	os_obj_stock_id	 		$auto_key_type $auto_key,
	os_hidden					bool,
	os_user_visi				varchar(255),
	os_db_admn_visi			varchar(255),
	os_create_date				timestamp,
	os_update_date				timestamp,
	os_modif_num				int2,
	os_obj_type_id				$key_type ,
	os_user_id					$key_type ,
	primary key(os_obj_stock_id)
)
"
,
"create index os_one"=>"create	index os_one on obj_stock (os_create_date)"
,
"create index os_two"=>"create	index os_two on obj_stock (os_user_id)"
,
"create index os_three"=>"create	index os_three on obj_stock (os_hidden,os_obj_type_id)"
,
"drope table obj_values cascade"=>"drop table obj_values cascade"
, 

"create table obj_values"=>"create table obj_values 
(
	ov_obj_stock_id	 		$key_type ,
	ov_charac_id				$key_type ,
	ov_charac_occur			int2  default 0,
	ov_update_date				timestamp,
	ov_coeff_unit_id			$key_type ,
	ov_value_txt				varchar(255),
	ov_value_float				float,
	ov_value_date				timestamp
)
"
,
"create index ov_one"=>"create	index ov_one on obj_values (ov_obj_stock_id,ov_charac_id,ov_charac_occur,ov_value_txt)"
,
"create index ov_two"=>"create	index ov_two on obj_values (ov_obj_stock_id,ov_charac_id,ov_charac_occur,ov_value_float)"	

);
foreach($req_tab as $doing=>$req)
{ 
	print("<hr>");
	$db->db_exec_no_trigger($req);
	if (!$db->err[0])
	{
		print ("<br>$doing ok");
	}
	else
	{
		$err_txt=$db->err[1];
		print("<br>-----Error $doing with : <br> $req : $err_txt----");
	}

	
}

?>

</body>
</html>
