<?php 
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

include("db_class.php");
class db_odbc_class extends db_class
{
	function db_odbc_class ($db_manufacturer,$db_name,$db_host,$db_user,$db_psw)
	{
		$this->db_name=$db_name;
		$this->db_host=$db_host;
		$this->db_user=$db_user;
		$this->db_psw=$db_psw;
		$this->db_manufacturer=$db_manufacturer;

	}
	function db_connect()
	{
		$this->db_con=odbc_connect($this->db_name,$this->db_user,$this->db_psw);
		if (!$this->db_con)
		{
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not establish connection with database $this->db_name at $this->db_host"
					."\n"."Some possible reason:"
					."\n"."the server isn't started" 
					."\n"."the database/servor name isn't right"
					."\n"."network problems(DNS,firewall,route)";
			$this->err=array(TRUE,& $msg);
			trigger_error($msg,E_USER_ERROR);
			return NULL;
		}
	}
	function db_close()
	{
		odbc_close($this->db_con);
	}
	function db_exec(&$request)
	{
		$this->err=array(FALSE,"");	
		$query=odbc_exec($this->db_con,$request);
		if ($query)
		{
			return $query;
		}
		else
		{
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not execute the request:"
					."\n"."$request";
			$this->err=array(TRUE,& $msg);	
			trigger_error($msg,E_USER_ERROR);
			return NULL;
		}

	}
	function db_exec_no_trigger(&$request)
	{
		$this->err=array(FALSE,"");	
		$query=odbc_exec($this->db_con,$request);
		if ($query)
		{
			return $query;
		}
		else
		{
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not execute the request:"
					."\n"."$request";
			$this->err=array(TRUE,& $msg);	
			return NULL;
		}

	}
	function db_num_rows (&$query)
	{
		return odbc_num_rows($query);
	}
	function db_fetch_row (&$query)
	{
		return FALSE;
	}
	function db_get_col()
	{
		return FALSE;
	}
	function db_fetch_array (&$query)
	{
		$array=array();
		odbc_fetch_into($query,$array);
		return $array;	
	}
	function db_insert_id ($table_key)
	{
		switch($this->db_manufacturer)
		{
			case 'mysql':
				$query="SELECT last_insert_id();"; 
				$res=$this->db_exec($query);	
				break;
			case 'postgree': 
				$query="SELECT currval('".$table_key."_seq') as key";
				$res=$this->db_exec($query);	
				break;
			default:
				break;				
		}
		$key=$this->db_fetch_array($res, 0);
		return $key[0];
	}


	function db_start_transaction()
	{
		switch($this->db_manufacturer)
		{
			case 'mysql': 
				$req="lock tables obj_stock write, obj_values write,coeff_unit read ;";
				break;
			case 'postgree': 
				$req="begin;";
				break;
			default:
				break;				
		}
		return $this->db_exec($req);

	}
	
	function db_end_transaction()
	{
		switch($this->db_manufacturer)
		{
			case 'mysql': 
				$req="unlock tables;";
				break;
			case 'postgree': 
				$req="commit;";
				break;
			default:
				break;				
		}
		return $this->db_exec($req);

	}
	function db_abort_transaction()
	{
		switch($this->db_manufacturer)
		{
			case 'mysql': 
				$req="unlock tables;";
				break;
			case 'postgree': 
				$req="rollback;";
				break;
			default:
				break;				
		}
		return $this->db_exec($req);

	}

	function db_free_result (&$query)
	{
		return odbc_free_result($query);
	}
	function db_error_msg()
	{
		return odbc_error($this->db_con);
	}
};
?>
