<?php 
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

include("db_class.php");
class db_postgree_class extends db_class
{
	var $current_tow_nbr;
	var $last_query;
	
	function db_postgree_class ($db_manufacturer,$db_name,$db_host,$db_user,$db_psw)
	{
		$this->db_name=$db_name;
		$this->db_host=$db_host;
		$this->db_user=$db_user;
		$this->db_psw=$db_psw;
		$this->db_manufacturer=$db_manufacturer;
		$this->err=array(FALSE,"");
	}
	function db_connect()
	{
		$string_con="host=$this->db_host dbname=$this->db_name user=$this->db_user";
		$this->con=pg_connect($string_con);
		if (!$this->con)
		{
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not establish connection with database $this->db_name at $this->db_host"
					."\n"."Some possible reason:"
					."\n"."the server isn't started" 
					."\n"."the database/servor name isn't right"
					."\n"."network problems(DNS,firewall,route)";
			$this->err=array(TRUE,& $msg);
			trigger_error($msg,E_USER_ERROR);
			return NULL;
		}
	}
	function db_close()
	{
		pg_close($this->con);
	}
	function db_exec(&$request)
	{
		$this->err=array(FALSE,"");	
		$this->last_query=pg_exec($this->con,$request);
		if ($this->last_query)
		{
			//$res=pg_query("SELECT currval('obj_stock_id_seq') as key");
			//$key=pg_fetch_array($res, 0);
			//print_debug("currval=$key");
			$this->current_row_nbr=0;
			return $this->last_query;
		}
		else
		{	
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not execute the request:"
					."\n"."$request";
			$this->err=array(TRUE,& $msg);	
			trigger_error($msg,E_USER_ERROR);
			return NULL;
		}
			

	}
	function db_exec_no_trigger(&$request)
	{
		$this->err=array(FALSE,"");	
		$this->last_query=pg_exec($this->con,$request);
		if ($this->last_query)
		{
			//$res=pg_query("SELECT currval('obj_stock_id_seq') as key");
			//$key=pg_fetch_array($res, 0);
			//print_debug("currval=$key");
			$this->current_row_nbr=0;
			return $this->last_query;
		}
		else
		{	
			$msg=$this->db_error_msg();
			$msg=	$msg
					."\n"."Can not execute the request:"
					."\n"."$request";
			$this->err=array(TRUE,& $msg);	
			return NULL;
		}
			

	}
	function db_num_rows (&$query)
	{
		return pg_numrows($query);
	}
	function db_fetch_row (&$query)
	{
		return FALSE;
	}
	function db_get_col()
	{
		return FALSE;
	}
	function db_fetch_array (&$query)
	{
//		 $row =pg_fetch_array($query,$this->current_row_nbr,PGSQL_NUM);
		 $row =pg_fetch_array($query);
		 $this->current_row_nbr++;
		 return $row;
	}
	function db_insert_id ($table_key)
	{
		$res=pg_query("SELECT currval('".$table_key."_seq') as key");	
		$key=pg_fetch_array($res, 0);
		return $key["key"];
	}

	function db_free_result (&$query)
	{
		return pg_freeresult($query);
	}
	function db_start_transaction()
	{
		$req="begin;";
		return $this->db_exec($req);

	}
	
	function db_end_transaction()
	{
		$req="commit;";
		return $this->db_exec($req);

	}
	function db_abort_transaction()
	{
		$req="rollback;";
		return $this->db_exec($req);

	}

	function db_error_msg()
	{
		return pg_errormessage($this->con);
	}
};
?>
