<?php
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

class stock_new_obj 
{
	var $err;
	var $db;						
	var $obj_type_id;				// the description of specific datas to describe the object
	var $obj_name;					// the description of specific datas to describe the object
	var $obj_stock_id;			// the id of the object stored in the database stock
	var $user_visi	;				// visibility allowed by the object owner 
	var $db_admn_visi;				// visibility allowed by the database administrator (user_id=0)
	var $request;					// contain the data send by the previous form
	var $form_line;				// contain the data use to generate the form (saved in session)
	var $datas_array;				// datas to be saved in session 	
	var $pgm_mod_nam;
	var $pgm_mod_opt;
	var $pgm_mod_arg;	
	function stock_new_obj(& $request, $session_var,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
	{
		global $err;
		$this->err=array(FALSE,"");
		// establish a link with the session 
		
		$this->form_line		= 	& $session_var["form_line"];
		$this->datas_array	= 	& $session_var["datas_array"];
		$this->request			=	& $request;
		$this->pgm_mod_nam	=	$pgm_mod_nam;	
		$this->pgm_mod_opt	=	$pgm_mod_opt;	
		$this->pgm_mod_arg	=	$pgm_mod_arg;	
		
		// create the class database and connect to it
		
		
		$db_conf=get_db_conf_file("db/db_conf.txt");
		// new_db_class isn't a constructor but an utility that generats class name
		// and create an instance of it 
		$this->db=new_db_class($db_conf);
		if ($err[0])
		{
			$this->err=array(TRUE,"Can not create the database interface class with the configuration file $db_conf");
			return NULL;
		}
		$this->db->db_connect();
		if ($this->db->err[0])
		{
			$this->err=array(TRUE,"\n"."Can not connect to the database see the application log-file");	
			return NULL;		
			
		}
				
		
		switch ($pgm_mod_nam)
		{
			case 'mod':
			case 'vis':
			case 'upd':
					$this->obj_stock_id=$this->request['obj_stock_id'];
					$arr_obj=array("","");
					$err=$this->get_obj_info($this->obj_stock_id,$arr_obj);			
					
					// verify if exists in the database
					if ($err[0])
					{
						// not found
						$this->err=$err;
					}
					else
					{									
						$this->obj_type_id = $arr_obj[0];
						// when extending a field we don't update the form with the 
						// data base values because the user could alrready have
						// modified the form
						if($this->pgm_mod_nam =="mod" && $this->pgm_mod_opt != "ext")
							$this->datas_array['update_num']	= $arr_obj[1];
					}		
					break;
		
			case 'cre':
			case 'ins':
					$this->obj_type_id=$this->request['obj_type_id'];
					$this->obj_name=$this->get_obj_type_info($this->obj_type_id);
					if(!isset($this->obj_name))
						$this->err=array(TRUE,"obj_type_id doesn't exist");			
					break;
			default:
					$this->err=array(TRUE,"pgm_mod doesn't exist");			
					break;
		}
		
		return NULL;				
		
	}
	function close_db()
	{
		$this->db->db_close();
	}
	function get_form_line()
	{
		switch ($this->pgm_mod_nam)
		{
			case 'cre':
				$req=
				"select	
							ch_charac_id,
							oc_required, 
							ch_charac_name, 
							ch_input_html_type, 
							ch_charac_type,
							ch_input_length,
							ch_input_decimal, 
							ch_unit_id, 				
							ch_ctl_type,
							ch_min_range,
							ch_max_range,
							oc_multi_occur,
							oc_init_occur 
				from 	
							obj_type,
							obj_charac,
							characteristic 
				where
							ot_obj_type_id= $this->obj_type_id
							and
							ot_obj_type_id=oc_obj_type_id
							and
							oc_charac_id=ch_charac_id 
				order by 
							oc_sequence asc
				;";
				break;
			
			case 'mod':
			case 'vis':
				$req=
				"select	
							ch_charac_id,
							oc_required, 
							ch_charac_name, 
							ch_input_html_type, 
							ch_charac_type,
							ch_input_length,
							ch_input_decimal, 
							ch_unit_id, 				
							ch_ctl_type,
							ch_min_range,
							ch_max_range,
							oc_multi_occur,
							oc_init_occur, 
							ov_value_txt,
							ov_coeff_unit_id,
							ov_charac_occur
				from 	
							obj_type,
							obj_charac,
							characteristic
				left join 
							obj_values 
							on 
								ov_obj_stock_id=$this->obj_stock_id 
								and 
								ov_charac_id=ch_charac_id
				where
							ot_obj_type_id= $this->obj_type_id
							and
							ot_obj_type_id=oc_obj_type_id
							and
							oc_charac_id=ch_charac_id 
				order by 
							oc_sequence asc,
							ov_charac_occur asc
							
				;";
				break;
			default:
				$this->err=array(TRUE,"pgm_mod invalid for this kind of request (cre/mod)");
				return;
				break;
		}
		$result= $this->db->db_exec($req);
		// bug : shold handle the errors in the sql request 
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			// bug : incomplete message obj_stock_id
			$this->err=array("No chartacteristic found for obj_type=  $this->obj_type_id");
			return NULL ;
		}
		else
		{	
			$this->form_line=NULL;			
			$i=0;
			while ($row=$this->db->db_fetch_array($result))
			{
			/*
				Return an array with data needed to generate the form
				
				
				0- 	The database column name or the id of the characteristic describing 
						the dynamic column 
				1- 	If the field must be filled (true/false)
				2- 	The field label to be printed 
				3- 	The type of entry (in the form : text , radio....)
				4- 	The type of data  (decimal, text, float)
				5- 	The length including decimal
				6- 	The number of decimal
				7- 	A list of [values,codes] permitted for this characteristic
				8- 	The value of the characteristic
				9- 	A list [code,abbr,value] permitted  for the coeff-unit  
				10- 	The Id  for the coeff-unit
				11-   Error message if data type in the form is wrong
				12-	Decimal control type (array including 1-type [none,range,unsigned]  2-min_range 3-max_range)
				13- 	Saved initial value from database
				14-	Saved initial coeff_unit value from database 
				15-	Value or coeff Modified TRUE/FALSE 
				16-   Not used in the pgm
				17- 	Characteristic occurence (as a part of the key)
				18-	multi occurence allowed (true/false)
				19-	initial occurence number used for occurence extension
				20-   Concurrent modification made in the database (true/false)
				21-   Last saved value from database (for concurrent database update)
				22-   Last saved coeff from database (for concurrent database update)
				23-	Notify message for concurrent database update 
			*/
				if (!($row[3] == "text"|| $row[3] == "textarea"))
				{
					$input_values=$this->get_input_values($row[0]);
					
				}
				else
					$input_values=array();
					
				switch ($this->pgm_mod_nam)				
				{
					case 'cre':
					
						// this is a creation
						$this->form_line[$i]		[0]	=$row[0];
						$this->form_line[$i]		[1]	=$row[1];
						$this->form_line[$i]		[2]	=$row[2];
						$this->form_line[$i]		[3]	=$row[3];
						$this->form_line[$i]		[4]	=$row[4];
						$this->form_line[$i]		[5]	=$row[5];
						$this->form_line[$i]		[6]	=$row[6];
						$this->form_line[$i]		[7]	=$input_values;
						$this->form_line[$i]		[8]	="";
						$this->form_line[$i]		[9]	=$this->get_coeff_units($row[7]);
						$this->form_line[$i]		[10]	=0;
						$this->form_line[$i]		[11]	="";
						$this->form_line[$i]		[12]	=array($row[8],$row[9],$row[10]);
						$this->form_line[$i]		[13]	="";
						$this->form_line[$i]		[14]	="";
						$this->form_line[$i]		[15]	="";
						$this->form_line[$i]		[16]	="";
						$this->form_line[$i]		[17]	=0;
						$this->form_line[$i]		[18]	=$row[11];
						$this->form_line[$i]		[19]	=$row[12];
						$this->form_line[$i]		[20]	=FALSE;
						$this->form_line[$i]		[21]	="";
						$this->form_line[$i]		[22]	="";
						$this->form_line[$i]		[23]	="";
						
						break;
						
					case 'mod':
					case 'vis':
					
						// this is a modification
						if (!isset($row[15])|| $row[15]==NULL) 
							$ww_occur=0;
						else
							$ww_occur=$row[15];
						
							
						$this->form_line[$i]		[0]	=$row[0];
						$this->form_line[$i]		[1]	=$row[1];
						$this->form_line[$i]		[2]	=$row[2];
						$this->form_line[$i]		[3]	=$row[3];
						$this->form_line[$i]		[4]	=$row[4];
						$this->form_line[$i]		[5]	=$row[5];
						$this->form_line[$i]		[6]	=$row[6];
						$this->form_line[$i]		[7]	=$input_values;
						$this->form_line[$i]		[8]	=$row[13];
						$this->form_line[$i]		[9]	=$this->get_coeff_units($row[7]);
						$this->form_line[$i]		[10]	=$row[14];
						$this->form_line[$i]		[11]	="";
						$this->form_line[$i]		[12]	=array($row[8],$row[9],$row[10]);
						$this->form_line[$i]		[13]	=$row[13];
						$this->form_line[$i]		[14]	=$row[14];
						$this->form_line[$i]		[15]	="";
						$this->form_line[$i]		[16]	="";
						$this->form_line[$i]		[17]	=$ww_occur;
						$this->form_line[$i]		[18]	=$row[11];
						$this->form_line[$i]		[19]	=$row[12];
						$this->form_line[$i]		[20]	=FALSE;
						$this->form_line[$i]		[21]	=$row[13];
						$this->form_line[$i]		[22]	=$row[14];
						$this->form_line[$i]		[23]	="";
						
						break;
					default:
						
						break;
				}	
			$i++;
			}
			$this->db->db_free_result($result);
			
			return;
		}
	}

	function get_input_values($charac_id)
	{
		$req=
		"select iv_input_values_id ,iv_input_values
		from  input_values 
		where
		iv_charac_id=$charac_id
		order by iv_sequence asc
		;"
		;
		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			$this->err=array(TRUE,"No input values found for charac_id = $charac_id ");
			return NULL ;
		}
		else
		{	
						
			while ($row=$this->db->db_fetch_array($result))
			{
							
				$returned_values[$row[1]]=$row[0];
			}
			$this->db->db_free_result($result);
			
			if(isset($returned_values))
				return $returned_values;
			else
				return array();
		}

	}
	function get_stock_value($obj_stock_id,$charac_id,$charac_occur)
	{
		$req=
		"select 
			ov_value_txt,
			ov_coeff_unit_id
		from  obj_values 
		where
		ov_obj_stock_id=$obj_stock_id
		and
		ov_charac_id=$charac_id
		and
		ov_charac_occur=$charac_occur
		;"
		;
		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			return array("","") ;
		}
		else
		{	
			$row=$this->db->db_fetch_array($result);
			$this->db->db_free_result($result);			
			return array($row[0],$row[1]);
		}

	}
	function get_obj_info($obj_stock_id,& $arr_obj)
	{
		$req=
		"select 
			os_obj_type_id,
			os_modif_num
		from  obj_stock
		where
		os_obj_stock_id=$obj_stock_id
		;"
		;
		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			// in this case no error message is printed 
			// because this not an application error
			return array(TRUE,"Object not found in the database");
		}
		else
		{	
						
			$row=$this->db->db_fetch_array($result);
			$arr_obj=array($row[0],$row[1]);
			$this->db->db_free_result($result);	
			return array(FALSE,"");
		}
	}
	function get_obj_type_info($obj_type_id)
	{
		$req=
		"select 
			ot_obj_name
		from  obj_type
		where
		ot_obj_type_id=$obj_type_id
		;"
		;
		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			// in this case no error message is printed 
			// because this not an application error
			return ;
		}
		else
		{	
						
			$row=$this->db->db_fetch_array($result);
			$this->db->db_free_result($result);
			return $row[0];			
		}

	}
	function get_coeff_units($unit_id)
	{
		$req=
		"select cu_coeff_unit_id,cu_abbrev 
		from  coeff_unit
		where
		cu_unit_id=$unit_id
		order by cu_sequence asc
		;"
		;
		
		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			return ;
		}
		else
		{	
						
			while ($row=$this->db->db_fetch_array($result))
			{
							
				$returned_coeff[$row[0]]=$row[1];
			}
			$this->db->db_free_result($result);
			
			if(isset($returned_coeff))
				return $returned_coeff;
			else
				return;

		}	
	}
	function regenerate_form_line($charac_id)
	{
		// opti: it would be normally faster to insert instead to copy
		// form_line array is generated by get_form_line and has one element for 
		// each characteristic and for all charateristics
		// regenerate is used to add characareristic-occurences when the user requires it
		

		$form_lin2=NULL;
		for($i=0;$i<count($this->form_line);$i++)
		{
			// opti: use a better name for the array key			
			//save the value allready typed in the form
			$request_form_key=$this->form_line[$i][0]."_".$this->form_line[$i][17];
			if (
					isset($this->request[$request_form_key])
//					&&
//					$this->request[$request_form_key]!=""
				)				
			{ 											
				$this->form_line[$i][8]=$this->request[$request_form_key];
			}
			
			$ww=$request_form_key."_coeff_id";	
			if (isset($this->request[$ww]))
			{
				$this->form_line[$i][10]=$this->request[$ww];
			}		

			//regenerate the form
			
			// add the exixiting lines 	
			// opti sould use a link instead of copy but didn't work!		
			$form_line2[]= $this->form_line[$i];			
			
			// add the extension 
			// check if the user ask to extend the line
			if ( $this->form_line[$i][0]==$charac_id)
			{
				// begin to insert new occurences only when have reached the last
				// exixting occurrence
				if (	isset($this->form_line[$i+1]) && $this->form_line[$i][0]!=$this->form_line[$i+1][0]
						||
						$i==count($this->form_line)-1
					)
				{
					// extend by the number of initial extension
					$ww_form_line2=$this->form_line[$i];
					// raz values
					$ww_form_line2[8]="";
					$ww_form_line2[11]="";
					$ww_form_line2[13]="";
					$ww_form_line2[14]="";
					$ww_form_line2[21]="";
					$ww_form_line2[22]="";
					
					for 	(	$ii=1+$this->form_line[$i][17];
								$ii<=($this->form_line[$i][17]+$this->form_line[$i][19]);
								$ii++
							)
					{
						//  set the characteristic occurence (the keys)
						$ww_form_line2[17]=$ii;
						
						// don't reset the coeff_value because to complicated the value will
						// be the last value typed by the user. 						
						
						// add the new line in the new form
						$form_line2[]= $ww_form_line2;
					}
				}
				
			}
		}
		//$this->form_line= NULL;		
		$this->form_line= $form_line2;
	}
	function validate_form()
	{
		
		// form_line array is generated by get_form_line and has one element for 
		// each characteristic and for all charateristics
		$form_err=FALSE;
		// validate the datas  
		for($i=0;$i<count($this->form_line);$i++)
		{
			// erase the previous error-message
			$this->form_line[$i][11]="";
			
			$request_form_key=$this->form_line[$i][0]."_".$this->form_line[$i][17];

			if (
						isset($this->request[$request_form_key])
						&&
						$this->request[$request_form_key]!=""
				)				
			{ 							
				// charasteristic data has been typed
				// store it in the form line for reprint
				
				$this->form_line[$i][8]=$this->request[$request_form_key];
									
				$ww=$request_form_key."_coeff_id";	
				if (isset($this->request[$ww]))
				{
					$this->form_line[$i][10]=$this->request[$ww];
				}		

				switch($this->form_line[$i][4])
				{
					// opti:test err_msg en sortant du switch
					case "text":
						// check the length
						if(strlen($this->form_line[$i][8])>$this->form_line[$i][5])
						{
							$this->form_line[$i][11]="String is too long";							
							$form_err=TRUE;
						}
						
						break;
						
					case "decimal":
						$form_err_msg=$this->control_decimal	(
																		$this->form_line[$i][8],
																		$this->form_line[$i][5],
																		$this->form_line[$i][6],							
																		$this->form_line[$i][12][0],							
																		$this->form_line[$i][12][1],							
																		$this->form_line[$i][12][2]
																	);
						if ($form_err_msg!="")
						{
							$this->form_line[$i][11]=$form_err_msg;							
							$form_err=TRUE;
						}
						
						break;
					case "float":
						$form_err_msg=$this->control_float	(
																		$this->form_line[$i][8],
																		$this->form_line[$i][12][0],							
																		$this->form_line[$i][12][1],							
																		$this->form_line[$i][12][2]
																	);
						if ($form_err_msg!="")
						{
							$this->form_line[$i][11]=$form_err_msg;							
							$form_err=TRUE;
						}
						else
						{
							//$this->form_line[$i][8]=(float)$this->form_line[$i][8];
						}
						break;
					case "object_id":
						$arr=NULL;
						$err=$this->get_obj_info($this->form_line[$i][8],$arr);
						if ($err[0])
						{
							$form_err=TRUE;
							$this->form_line[$i][11]=$err[1];							
							
						}
						break;
					default:
						break;
				}
			
				// for multiple occurence field with requested value : memorize that at least one 
				// occurence has been given
				if (isset($multi_occur[$this->form_line[$i][0]]))
					$multi_occur[$this->form_line[$i][0]]++;
				else
					$multi_occur[$this->form_line[$i][0]]=1;
			}
			else
			{
				// No data have been type for this line
				$this->form_line[$i][8]="";

				// wait to be on the last occurence to update message error
				// asking to type the requested value
				if (	
						(	isset($this->form_line[$i+1][0])
							&&
							$this->form_line[$i][0] != $this->form_line[$i+1][0]
						)
						||
						$i==count($this->form_line)-1
					)
				{
					// verify if at least one occurence has been typed
					if (	$this->form_line[$i][1] 
							&&
							!isset($multi_occur[$this->form_line[$i][0]])
						)
					{
						$this->form_line[$i][11]="Value required ";							
						$form_err=TRUE;
					}										
				}
			}
			// memorize if the data has been modified
			$this->form_line[$i][15]= (
													(
														$this->form_line[$i][8]
														!=
														$this->form_line[$i][13]
													)
													||
													(
														$this->form_line[$i][10]
														!=
														$this->form_line[$i][14]
													)
												);
			
		}
		return array($form_err,"");
	}
	function control_float($str="",$ctl_type,$min_range,$max_range)
	{
		// suppress the blanks
		$str=trim($str);
		
		// replace e with E and supress , 
		$str=strtr(	$str,
						Array(
									'e'=>'E',
									','=>'',
								)
					);
		
		// control that only one decimal separator has been used
		if (substr_count($str,".")>1)
			return "Only one decimal separator";
			
		// control that only one exposant separator has been used
		if (substr_count($str,"E")>1 )
			return "Only one exposant separator";
		
		// control that digits have been used or authorized characters 
		$strstr=strtr	(	$str,
								Array(
											'E'=>'',
											'.'=>'',
											'+'=>'',
											'-'=>'',
											','=>''
										)
							);
		
		if ($strstr!=""  && !ctype_digit($strstr))			
			return "You must enter digits or E or ."; 
		
		
		// separate the mantisse and exposant
			// replace the exposant separator to permit the scanf
			$strstr=str_replace("E","\t",$str);
		
		
			// explode in two parts mantisse and exposant
			list($man,$exp)=sscanf($strstr,"%s\t%s");
		
		// bug : and the sign?
		// remove heading  0 in the mantisse 
		$man=ereg_replace('^0*',"",$man);
		$man=strtr(	$man,
						Array(
									'+'=>'',
									'-'=>''
								)
					 );
					 
		// remove trailing  0 in the mantisse only if integer
		$dec_pos=strpos($man,".");
		if ($dec_pos)
			$man=ereg_replace('0*$',"",$man);
		else
			$dec_pos=strlen($man);
		// control that the precision is supported (number of digits
		if (strlen(str_replace(".","",$man)) > 7)
			return "Too much digits, the precision supported is 7 digits";
		
		// control that the exposant is supported
		if (	($dec_pos-1+abs((int)$exp))
				 >
				 30)
			return "Number out of scale [-E30,+E30]";
		
		// control that no decimal separator has been used in the exposant
		if (substr_count($exp,".")>0)
			return "The exposant must be integer";
		
		//convert to float
		$flt=(float)$str;
		 
		// control the range  (unsigned or range)
		switch ($ctl_type)
		{
			case 'unsigned':
				if ($flt <0)
						return "The number must be positiv or null";
				break;
			case 'range':
				if (	$flt <$min_range 
						||
						$flt >$max_range
					 )
						return "The number is out of range ". "[$min_range] to [$max_range]";
				break;
			default:
				break;
		}
	}
	function control_decimal($str="",$max_len,$max_dec,$ctl_type,$min_range,$max_range)
	{
		// suprress the blanks
		$str=trim($str);
		
		// count decimal separator
		if (substr_count($str,".")>1)
			return "Only one decimal separator";
		
		// suppress the 'thousand' separator
		$str=str_replace(",","",$str);
		
		// replace the decimal separator to permit the scanf
		$str=str_replace(".","\t",$str);
				
		// explode in two parts integer and decimal part
		list($int,$dec)=sscanf($str,"%s\t%s");
		
		if($int!="")
		{
			$sign=substr($int,0,1);
			if($sign=="-"||$sign=="+")
				$sub_int=substr($int,1);
			else							
				$sub_int=& $int;
			
			if($ctl_type=='unsigned' && $sign=="-")
				return "The number must be positive or null"; 

			if ($sub_int != ""&& !ctype_digit($sub_int))			
				return "You must enter digits in the integer part";
			$len=strlen($sub_int);	 
			$mxi_len=$max_len-$max_dec;
			
						
			if( $len > $mxi_len )
					return "Too much digits in the integer part";							

		}
		 				
		if ($dec!=""&& !ctype_digit($dec))			
			return "You must enter digits in the decimal part"; 
						
	
		if(strlen($dec)>$max_dec)
			if ($max_dec==0)
				return "No decimal for integer";		
			else
				return "Too much digits in the decimal part";		
								
		if ($ctl_type=='range')
			if (
					(float)$str< $min_range
					||
					(float)$str> $max_range
				)
			return "out of range : [$min_range,$max_range]";							
				
					
		return "";
	}
	function db_update($pgm_mod_opt)
	{
		// lock read obj_stock table 
		$this->db->db_start_transaction();
				
		// check if  the number of modifications has changed
		$err=$this->get_obj_info($this->obj_stock_id,$arr_obj_inf);			
		if ($err[0])
		{
				$this->db->db_abort_transaction();
				$this->err=array(TRUE,"Some body deleted the object since you started modifying");
				return "DELETED"; 
		}
		$upd_err="";
		if ($arr_obj_inf[1] != $this->datas_array['update_num'])
		{
			/* verify if somebody has also modified information since  
			 starting the modification  and set an error message.
			 if some body changed an information that has not been
			 modified in this form, no message will be given.
			 so datas in the file may be different of what the user
			 got on his screen just before click on modify button
			*/			 
			for($i=0;$i<count($this->form_line);$i++)
			{
				if($this->form_line[$i][15])
				{
					$stock_value=$this->get_stock_value($this->obj_stock_id,$this->form_line[$i][0],$this->form_line[$i][17]);
					// debug 
					/*
					print_r($stock_value);
					print("<hr>");
					print_r($this->form_line[$i]);
					print("<hr>");
					*/
					if($pgm_mod_opt =="kee" ||$pgm_mod_opt=="ovr")
					{
						$ww_comp_value=$this->form_line[$i][21];
						$ww_comp_coeff =$this->form_line[$i][22];
					}
					else
					{
						$ww_comp_value=$this->form_line[$i][13];
						$ww_comp_coeff =$this->form_line[$i][14];					
					}
							
						
						
					// check if the value data has changed  in the database
					if ($stock_value[0]!=$ww_comp_value)
					{
						
						$this->form_line[$i][20]=TRUE;
						$this->form_line[$i][23]
						=
						"Somebody has changed the value to [$stock_value[0]] since you started modifying";
						$upd_err="CONFIRMATION";
						// memorize the new value to detect a user modifying  again the file
						$this->form_line[$i][21]=$stock_value[0]; 
						
					}
					// check if the coeff has changed	in hte database			
					if ($stock_value[1]!=$ww_comp_coeff)
					{
						$this->form_line[$i][20]=TRUE;
						
						$this->form_line[$i][23]
						=
						$this->form_line[$i][23] .
						"\nSomebody has changed the coeeficient to [$stock_value[1]] since you started modifying";
						$upd_err="CONFIRMATION";
						// memorize the new value to detect a user modifying  again the file
						$this->form_line[$i][22]=$stock_value[1]; 
					}
				}
			}
			
			if ($upd_err!="")
			{	
				$this->db->db_abort_transaction();
				return $upd_err; 
			}	
		}

		// the object can be modified without asking for confirmation to the user
		// modify obj_stock
		$this->update_obj_stock($this->obj_stock_id);
			
		// modify obj_values
		for($i=0;$i<count($this->form_line);$i++)
		{
			if($this->form_line[$i][15])
			{
				// errase the error messages for concrurrent database updat
				$this->form_line[$i][23]="";

				// if thereis concurrent database modification  and the user wants
				// to keep them :  do not update 
				if(!($this->form_line[$i][20]==TRUE && $pgm_mod_opt=="kee"))
				{
					if($this->form_line[$i][8]=="")
					{
						$this->delete_obj_value($this->obj_stock_id,$this->form_line[$i][0],$this->form_line[$i][17]);
					}
					else
					{
						// a data has been type in the form 
						// check if the data value exist to either insert or modify
						$stock_value=$this->get_stock_value($this->obj_stock_id,$this->form_line[$i][0],$this->form_line[$i][17]);
						
						if ($stock_value[0]=="")
							$this->insert_obj_values(
																$this->obj_stock_id,
																$this->form_line[$i][0],
																$this->form_line[$i][4],
																$this->form_line[$i][17],
																$this->form_line[$i][8],
																$this->form_line[$i][10]
															);				
						else
							$this->update_obj_value(
																$this->obj_stock_id,
																$this->form_line[$i][0],
																$this->form_line[$i][4],
																$this->form_line[$i][17],
																$this->form_line[$i][8],
																$this->form_line[$i][10]
															);
					}
				}
				else
				{
					$this->form_line[$i][8]=$this->form_line[$i][21];
					$this->form_line[$i][10]=$this->form_line[$i][22];
					
				}
			}
		}			
		// unlock the table obj_stock
		$this->db->db_end_transaction();
		return "";
	}
	function update_obj_stock($obj_stock_id)
	{
		$req=
		"update obj_stock
		set
			os_modif_num=os_modif_num+1,
			os_update_date=NOW()
		where
			os_obj_stock_id=$obj_stock_id
		;";
		
		$result=$this->db->db_exec($req);
		if ($this->db->err[0])
			$this->err=$this->db->err;
		
	}
	function update_obj_stock_visibity($obj_stock_id,$user,$visibility)
	{
		// change the visibility for the one who query the database
		if ($user==0)
		{
			// in this case the db administrator want to change visibility  
			
			if($this->user_visi=='online'||$visibility=='online' )
				$os_hidden=FALSE;
			else
			   $os_hidden=TRUE;
			$sub_req=
			"
				os_hidden=$os_hidden,
				os_db_admn_visi=$visibility,
			";
		}
		else
		{
			// in this case the user owner want to change visibility
			if($this->db_admn_visi=='online'||$visibility=='online' )
				$os_hidden=FALSE;
			else
			   $os_hidden=TRUE;
			$sub_req=
			"
				os_hidden=$os_hidden,
				os_user_visi=$visibility,
			";
		}
			$req=
			"update obj_stock
			set
				$sub_req
				os_modif_num=os_modif_num+1,
				os_update_date=NOW()
			where
				os_obj_stock_id=$obj_stock_id
			;";
		$result=$this->db->db_exec($req);
		if ($this->db->err[0])
			$this->err=$this->db->err;
		
	}
	function update_obj_value(	$ov_obj_stock_id,$ov_charac_id,$ch_charac_type,
										$ov_charac_occur="0",$ov_value_txt,$ov_coeff_unit_id="0")
	{
			
		
		// because of the comma that might cause an error in the sql request
		// bug what if it isn't a number? comma should'nt be suppressed in text.
		$ov_value_txt=addslashes($ov_value_txt);
		$value_txt=	str_replace(",","",$ov_value_txt);

		if($ch_charac_type == "decimal" ||	$ch_charac_type == "float")
		{	
			if($ov_coeff_unit_id !="0"  && $ov_coeff_unit_id !="")
				$real_float_value= $this->get_real_float_value($ov_coeff_unit_id,$value_txt);			
			else
				$real_float_value=$value_txt;
		}
		else
		{
			$real_float_value=0;
		}
		$req=
		"update obj_values 
		set		
			ov_update_date =NOW(),
			ov_value_txt 	='$ov_value_txt',
			ov_value_float	='$real_float_value',
			ov_coeff_unit_id='$ov_coeff_unit_id'
		where
			ov_obj_stock_id=$ov_obj_stock_id
			and
			ov_charac_id=$ov_charac_id
			and
			ov_charac_occur=$ov_charac_occur
		 ;";
		
		$result=$this->db->db_exec($req);
		if ($this->db->err[0])
			$this->err=$this->db->err;
	
	}
	function delete_obj_value($ov_obj_stock_id,$ov_charac_id,$ov_charac_occur)
	{
		$req=
		"delete from obj_values 
		where
			ov_obj_stock_id=$ov_obj_stock_id
			and
			ov_charac_id=$ov_charac_id
			and
			ov_charac_occur=$ov_charac_occur
		 ;";
		
		$result=$this->db->db_exec($req);
		if ($this->db->err[0])
			$this->err=$this->db->err;

	
	}
	// opti: put the three functions in one and suprress the switch
	function db_insert()
	{
			// obj_stock and get obj_stock_id
			$this->obj_stock_id=$this->insert_obj_stock($this->obj_type_id,1);
			if ($this->err[0])
					return NULL;						
			// insert obj_values
			// opti use loop  for(....
			foreach($this->form_line as $line)
			{
				if (isset($line[8]) && $line[8]!="")			
							$this->insert_obj_values($this->obj_stock_id,$line[0],$line[4],$line[17],$line[8],$line[10]);
							if ($this->err[0])
							{
								return NULL;						
							}
			}
	}
	function insert_obj_stock($obj_type_id,$user_id)
	{
		$req=
		"insert into obj_stock
		(			
			os_create_date,
			os_update_date,
			os_modif_num,
			os_obj_type_id,
			os_user_id
		) 
		values 
		(
			NOW(),
			NOW(),
			0,
			'$obj_type_id',
			'$user_id'
		)";
		
		$result=$this->db->db_exec($req);
		if ($this->db->err[0])
		{
			$this->err=$this->db->err;
			return NULL;
		}
		else
		{		
			return $this->db->db_insert_id("obj_stock_os_obj_stock_id");
		}
	}
	function insert_obj_values($ov_obj_stock_id,$ov_charac_id,$ch_charac_type,$ov_charac_occur="0",$ov_value_txt,$ov_coeff_unit_id)
	{
		// because of the comma
		$ov_value_txt=addslashes($ov_value_txt);
		$value_txt=	str_replace(",","",$ov_value_txt);
		if($ch_charac_type=="decimal" ||  $ch_charac_type=="float")
		{
			if($ov_coeff_unit_id !="0"  && $ov_coeff_unit_id !="")
				$real_float_value= $this->get_real_float_value($ov_coeff_unit_id,$ov_value_txt);						
			else
			{
				$real_float_value=$value_txt;
				
			}
		}
		else
		$real_float_value="0";
		$req=
		"insert into obj_values
		(	ov_obj_stock_id, 
			ov_charac_id, 
			ov_charac_occur, 
			ov_update_date, 
			ov_value_txt, 
			ov_coeff_unit_id, 
			ov_value_float
		) 
		values 
		(	'$ov_obj_stock_id',
			'$ov_charac_id',
			'$ov_charac_occur',
			NOW(),
			'$ov_value_txt',
			'$ov_coeff_unit_id',
			'$real_float_value'
		 )";
		
		$this->db->db_exec($req);
		if ($this->db->err[0])
			$this->err=$this->db->err;
				
	}
	function get_real_float_value($ov_coeff_unit_id,$value_txt)
	{
			// get the coeff to calculate the real float value
			$req=
			"select 
				cu_coeff_value * $value_txt 
			from 
				coeff_unit 
			where 
				cu_coeff_unit_id=$ov_coeff_unit_id
			limit 1
			;"
			;
			$result=$this->db->db_exec($req);
			$result_num=$this->db->db_num_rows($result);
			if ($result_num == 0)
			{
				print_error("Coeff_id : $ov_coeff_unit_id not found ");
				return  ;
			}
			else
			{	
							
				$row=$this->db->db_fetch_array($result);
				$this->db->db_free_result($result);
				return $row[0];
			}

	}
};
?>
