<?php
	
	/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

	function get_date_time ()
	{
		return date("Y-m-d H:i;s",time());
	}
	function get_db_conf_file($db_file)
	{
		if(file_exists($db_file))
		
			return join('',file($db_file));
		else
			return "";

	}
	function &new_db_class($db_conf_file)
	{
	
	
		global $err;
		/* 
			Generate the name of the class to create depending  on the configuration file
			and create an instance of the class from this name.
			
			Parameter $db_conf_file is the name of a file containig this intructions  
			
			$db_type= 	mysql, odbc .....
			$db_host=  server name
			$db_name=	database name 
			$db_user=  user name
			$db_psw=	user password		
		 
		*/
		if (!is_file($db_conf_file))
		{	
			$msg="Cannot find $db_conf_file";
			trigger_error($msg ,E_USER_ERROR); 		
			$err=array(TRUE,$msg);
			return NULL;
		}
		include("$db_conf_file"); 
		
		$class_inc="db_${db_type}.php";		
		if (!is_file($class_inc))
		{
			$msg="Cannot find $class_inc";
			trigger_error($msg ,E_USER_ERROR); 
			$err=array(TRUE,$msg);
			return NULL;
		}
		include($class_inc);
	
		$class_name="db_".$db_type."_class";		
		$eval_string ="return new ".$class_name."('$db_manufacturer','$db_name','$db_host','$db_user','$db_psw');";
		$db_class=eval("$eval_string");	
		
		if ($db_class)
		{
			if ($db_class->err[0])
			{
				$err=array(TRUE,"Can not instance the class $class_name error  retuned by the constructor");
			}
			else
			return $db_class;
		}
		else
		{
				$msg="Cannot create database class object $class_name from file $db_conf_file";
				trigger_error($msg,E_USER_ERROR); 
				$err=array(TRUE,$msg);
				return NULL;
		}
	
	}	

// user defined error handling function
function error_handler ($errno, $errmsg, $filename, $linenum, $vars) {
    // timestamp for the error entry
    $dt = date("Y-m-d H:i:s (T)");

    // define an assoc array of error string
    // in reality the only entries we should
    // consider are 2,8,256,512 and 1024
    $errortype = array (
                1   =>  "e_Error",
                2   =>  "e_Warning",
                4   =>  "e_Parse",
                8   =>  "e_Notice",
                16  =>  "e_Core_Error",
                32  =>  "e_Core_Warning",
                64  =>  "e_Compile_Error",
                128 =>  "e_Compile_Warning",
                256 =>  "e_User_Error",
                512 =>  "e_User_Warning",
                1024=>  "e_User_Notice"
                );
   
	 $err = "\n$dt "."$errortype[$errno] "."$filename "."$linenum\n".$errmsg;
/*
    if (in_array($errno, $user_errors))
        $err .= "\t<vartrace>".wddx_serialize_value($vars,"Variables")."</vartrace>\n";
*/    
    // for testing
     //print_debug($err);

    // save to the error log, and e-mail me if there is a critical user error
	 $errlog1="webstock.log"; 
	 //debug
	 unlink($errlog1);
	 if (!is_file($errlog1))
	 {	
	 	touch($errlog1);
	 }
    error_log($err, 3, $errlog1);
	 
/*	 $errlog2="/var/log/httpd/webstock.log";
	 if (!is_file($errlog2))
	 	touch($errlog2);
    error_log($err, 3, $errlog2);
*/	 
    
	 if ($errno & (E_ERROR|E_CORE_ERROR|E_COMPILE_ERROR|E_USER_ERROR))
	 {
        mail("dechicom","Critical Error",$err);
	}
}
//error_reporting(0);
//$old_error_handler = set_error_handler("error_handler");
$err=NULL;

?>
